/**
 * Autogenerated by Thrift Compiler (0.13.0)
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 *  @generated
 */
package org.eclipse.hawk.service.api;

@SuppressWarnings({"cast", "rawtypes", "serial", "unchecked", "unused"})
@javax.annotation.Generated(value = "Autogenerated by Thrift Compiler (0.13.0)", date = "2021-04-18")
public class ModelSpec implements org.apache.thrift.TBase<ModelSpec, ModelSpec._Fields>, java.io.Serializable, Cloneable, Comparable<ModelSpec> {
  private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("ModelSpec");

  private static final org.apache.thrift.protocol.TField URI_FIELD_DESC = new org.apache.thrift.protocol.TField("uri", org.apache.thrift.protocol.TType.STRING, (short)1);
  private static final org.apache.thrift.protocol.TField METAMODEL_URIS_FIELD_DESC = new org.apache.thrift.protocol.TField("metamodelUris", org.apache.thrift.protocol.TType.LIST, (short)2);

  private static final org.apache.thrift.scheme.SchemeFactory STANDARD_SCHEME_FACTORY = new ModelSpecStandardSchemeFactory();
  private static final org.apache.thrift.scheme.SchemeFactory TUPLE_SCHEME_FACTORY = new ModelSpecTupleSchemeFactory();

  public @org.apache.thrift.annotation.Nullable java.lang.String uri; // required
  public @org.apache.thrift.annotation.Nullable java.util.List<java.lang.String> metamodelUris; // required

  /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
  public enum _Fields implements org.apache.thrift.TFieldIdEnum {
    URI((short)1, "uri"),
    METAMODEL_URIS((short)2, "metamodelUris");

    private static final java.util.Map<java.lang.String, _Fields> byName = new java.util.HashMap<java.lang.String, _Fields>();

    static {
      for (_Fields field : java.util.EnumSet.allOf(_Fields.class)) {
        byName.put(field.getFieldName(), field);
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, or null if its not found.
     */
    @org.apache.thrift.annotation.Nullable
    public static _Fields findByThriftId(int fieldId) {
      switch(fieldId) {
        case 1: // URI
          return URI;
        case 2: // METAMODEL_URIS
          return METAMODEL_URIS;
        default:
          return null;
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, throwing an exception
     * if it is not found.
     */
    public static _Fields findByThriftIdOrThrow(int fieldId) {
      _Fields fields = findByThriftId(fieldId);
      if (fields == null) throw new java.lang.IllegalArgumentException("Field " + fieldId + " doesn't exist!");
      return fields;
    }

    /**
     * Find the _Fields constant that matches name, or null if its not found.
     */
    @org.apache.thrift.annotation.Nullable
    public static _Fields findByName(java.lang.String name) {
      return byName.get(name);
    }

    private final short _thriftId;
    private final java.lang.String _fieldName;

    _Fields(short thriftId, java.lang.String fieldName) {
      _thriftId = thriftId;
      _fieldName = fieldName;
    }

    public short getThriftFieldId() {
      return _thriftId;
    }

    public java.lang.String getFieldName() {
      return _fieldName;
    }
  }

  // isset id assignments
  public static final java.util.Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
  static {
    java.util.Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new java.util.EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
    tmpMap.put(_Fields.URI, new org.apache.thrift.meta_data.FieldMetaData("uri", org.apache.thrift.TFieldRequirementType.REQUIRED, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.STRING)));
    tmpMap.put(_Fields.METAMODEL_URIS, new org.apache.thrift.meta_data.FieldMetaData("metamodelUris", org.apache.thrift.TFieldRequirementType.REQUIRED, 
        new org.apache.thrift.meta_data.ListMetaData(org.apache.thrift.protocol.TType.LIST, 
            new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.STRING))));
    metaDataMap = java.util.Collections.unmodifiableMap(tmpMap);
    org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(ModelSpec.class, metaDataMap);
  }

  public ModelSpec() {
  }

  public ModelSpec(
    java.lang.String uri,
    java.util.List<java.lang.String> metamodelUris)
  {
    this();
    this.uri = uri;
    this.metamodelUris = metamodelUris;
  }

  /**
   * Performs a deep copy on <i>other</i>.
   */
  public ModelSpec(ModelSpec other) {
    if (other.isSetUri()) {
      this.uri = other.uri;
    }
    if (other.isSetMetamodelUris()) {
      java.util.List<java.lang.String> __this__metamodelUris = new java.util.ArrayList<java.lang.String>(other.metamodelUris);
      this.metamodelUris = __this__metamodelUris;
    }
  }

  public ModelSpec deepCopy() {
    return new ModelSpec(this);
  }

  @Override
  public void clear() {
    this.uri = null;
    this.metamodelUris = null;
  }

  @org.apache.thrift.annotation.Nullable
  public java.lang.String getUri() {
    return this.uri;
  }

  public ModelSpec setUri(@org.apache.thrift.annotation.Nullable java.lang.String uri) {
    this.uri = uri;
    return this;
  }

  public void unsetUri() {
    this.uri = null;
  }

  /** Returns true if field uri is set (has been assigned a value) and false otherwise */
  public boolean isSetUri() {
    return this.uri != null;
  }

  public void setUriIsSet(boolean value) {
    if (!value) {
      this.uri = null;
    }
  }

  public int getMetamodelUrisSize() {
    return (this.metamodelUris == null) ? 0 : this.metamodelUris.size();
  }

  @org.apache.thrift.annotation.Nullable
  public java.util.Iterator<java.lang.String> getMetamodelUrisIterator() {
    return (this.metamodelUris == null) ? null : this.metamodelUris.iterator();
  }

  public void addToMetamodelUris(java.lang.String elem) {
    if (this.metamodelUris == null) {
      this.metamodelUris = new java.util.ArrayList<java.lang.String>();
    }
    this.metamodelUris.add(elem);
  }

  @org.apache.thrift.annotation.Nullable
  public java.util.List<java.lang.String> getMetamodelUris() {
    return this.metamodelUris;
  }

  public ModelSpec setMetamodelUris(@org.apache.thrift.annotation.Nullable java.util.List<java.lang.String> metamodelUris) {
    this.metamodelUris = metamodelUris;
    return this;
  }

  public void unsetMetamodelUris() {
    this.metamodelUris = null;
  }

  /** Returns true if field metamodelUris is set (has been assigned a value) and false otherwise */
  public boolean isSetMetamodelUris() {
    return this.metamodelUris != null;
  }

  public void setMetamodelUrisIsSet(boolean value) {
    if (!value) {
      this.metamodelUris = null;
    }
  }

  public void setFieldValue(_Fields field, @org.apache.thrift.annotation.Nullable java.lang.Object value) {
    switch (field) {
    case URI:
      if (value == null) {
        unsetUri();
      } else {
        setUri((java.lang.String)value);
      }
      break;

    case METAMODEL_URIS:
      if (value == null) {
        unsetMetamodelUris();
      } else {
        setMetamodelUris((java.util.List<java.lang.String>)value);
      }
      break;

    }
  }

  @org.apache.thrift.annotation.Nullable
  public java.lang.Object getFieldValue(_Fields field) {
    switch (field) {
    case URI:
      return getUri();

    case METAMODEL_URIS:
      return getMetamodelUris();

    }
    throw new java.lang.IllegalStateException();
  }

  /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
  public boolean isSet(_Fields field) {
    if (field == null) {
      throw new java.lang.IllegalArgumentException();
    }

    switch (field) {
    case URI:
      return isSetUri();
    case METAMODEL_URIS:
      return isSetMetamodelUris();
    }
    throw new java.lang.IllegalStateException();
  }

  @Override
  public boolean equals(java.lang.Object that) {
    if (that == null)
      return false;
    if (that instanceof ModelSpec)
      return this.equals((ModelSpec)that);
    return false;
  }

  public boolean equals(ModelSpec that) {
    if (that == null)
      return false;
    if (this == that)
      return true;

    boolean this_present_uri = true && this.isSetUri();
    boolean that_present_uri = true && that.isSetUri();
    if (this_present_uri || that_present_uri) {
      if (!(this_present_uri && that_present_uri))
        return false;
      if (!this.uri.equals(that.uri))
        return false;
    }

    boolean this_present_metamodelUris = true && this.isSetMetamodelUris();
    boolean that_present_metamodelUris = true && that.isSetMetamodelUris();
    if (this_present_metamodelUris || that_present_metamodelUris) {
      if (!(this_present_metamodelUris && that_present_metamodelUris))
        return false;
      if (!this.metamodelUris.equals(that.metamodelUris))
        return false;
    }

    return true;
  }

  @Override
  public int hashCode() {
    int hashCode = 1;

    hashCode = hashCode * 8191 + ((isSetUri()) ? 131071 : 524287);
    if (isSetUri())
      hashCode = hashCode * 8191 + uri.hashCode();

    hashCode = hashCode * 8191 + ((isSetMetamodelUris()) ? 131071 : 524287);
    if (isSetMetamodelUris())
      hashCode = hashCode * 8191 + metamodelUris.hashCode();

    return hashCode;
  }

  @Override
  public int compareTo(ModelSpec other) {
    if (!getClass().equals(other.getClass())) {
      return getClass().getName().compareTo(other.getClass().getName());
    }

    int lastComparison = 0;

    lastComparison = java.lang.Boolean.valueOf(isSetUri()).compareTo(other.isSetUri());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetUri()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.uri, other.uri);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = java.lang.Boolean.valueOf(isSetMetamodelUris()).compareTo(other.isSetMetamodelUris());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetMetamodelUris()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.metamodelUris, other.metamodelUris);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    return 0;
  }

  @org.apache.thrift.annotation.Nullable
  public _Fields fieldForId(int fieldId) {
    return _Fields.findByThriftId(fieldId);
  }

  public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
    scheme(iprot).read(iprot, this);
  }

  public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
    scheme(oprot).write(oprot, this);
  }

  @Override
  public java.lang.String toString() {
    java.lang.StringBuilder sb = new java.lang.StringBuilder("ModelSpec(");
    boolean first = true;

    sb.append("uri:");
    if (this.uri == null) {
      sb.append("null");
    } else {
      sb.append(this.uri);
    }
    first = false;
    if (!first) sb.append(", ");
    sb.append("metamodelUris:");
    if (this.metamodelUris == null) {
      sb.append("null");
    } else {
      sb.append(this.metamodelUris);
    }
    first = false;
    sb.append(")");
    return sb.toString();
  }

  public void validate() throws org.apache.thrift.TException {
    // check for required fields
    if (uri == null) {
      throw new org.apache.thrift.protocol.TProtocolException("Required field 'uri' was not present! Struct: " + toString());
    }
    if (metamodelUris == null) {
      throw new org.apache.thrift.protocol.TProtocolException("Required field 'metamodelUris' was not present! Struct: " + toString());
    }
    // check for sub-struct validity
  }

  private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
    try {
      write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
    } catch (org.apache.thrift.TException te) {
      throw new java.io.IOException(te);
    }
  }

  private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, java.lang.ClassNotFoundException {
    try {
      read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
    } catch (org.apache.thrift.TException te) {
      throw new java.io.IOException(te);
    }
  }

  private static class ModelSpecStandardSchemeFactory implements org.apache.thrift.scheme.SchemeFactory {
    public ModelSpecStandardScheme getScheme() {
      return new ModelSpecStandardScheme();
    }
  }

  private static class ModelSpecStandardScheme extends org.apache.thrift.scheme.StandardScheme<ModelSpec> {

    public void read(org.apache.thrift.protocol.TProtocol iprot, ModelSpec struct) throws org.apache.thrift.TException {
      org.apache.thrift.protocol.TField schemeField;
      iprot.readStructBegin();
      while (true)
      {
        schemeField = iprot.readFieldBegin();
        if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
          break;
        }
        switch (schemeField.id) {
          case 1: // URI
            if (schemeField.type == org.apache.thrift.protocol.TType.STRING) {
              struct.uri = iprot.readString();
              struct.setUriIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 2: // METAMODEL_URIS
            if (schemeField.type == org.apache.thrift.protocol.TType.LIST) {
              {
                org.apache.thrift.protocol.TList _list8 = iprot.readListBegin();
                struct.metamodelUris = new java.util.ArrayList<java.lang.String>(_list8.size);
                @org.apache.thrift.annotation.Nullable java.lang.String _elem9;
                for (int _i10 = 0; _i10 < _list8.size; ++_i10)
                {
                  _elem9 = iprot.readString();
                  struct.metamodelUris.add(_elem9);
                }
                iprot.readListEnd();
              }
              struct.setMetamodelUrisIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          default:
            org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();

      // check for required fields of primitive type, which can't be checked in the validate method
      struct.validate();
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot, ModelSpec struct) throws org.apache.thrift.TException {
      struct.validate();

      oprot.writeStructBegin(STRUCT_DESC);
      if (struct.uri != null) {
        oprot.writeFieldBegin(URI_FIELD_DESC);
        oprot.writeString(struct.uri);
        oprot.writeFieldEnd();
      }
      if (struct.metamodelUris != null) {
        oprot.writeFieldBegin(METAMODEL_URIS_FIELD_DESC);
        {
          oprot.writeListBegin(new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.STRING, struct.metamodelUris.size()));
          for (java.lang.String _iter11 : struct.metamodelUris)
          {
            oprot.writeString(_iter11);
          }
          oprot.writeListEnd();
        }
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

  }

  private static class ModelSpecTupleSchemeFactory implements org.apache.thrift.scheme.SchemeFactory {
    public ModelSpecTupleScheme getScheme() {
      return new ModelSpecTupleScheme();
    }
  }

  private static class ModelSpecTupleScheme extends org.apache.thrift.scheme.TupleScheme<ModelSpec> {

    @Override
    public void write(org.apache.thrift.protocol.TProtocol prot, ModelSpec struct) throws org.apache.thrift.TException {
      org.apache.thrift.protocol.TTupleProtocol oprot = (org.apache.thrift.protocol.TTupleProtocol) prot;
      oprot.writeString(struct.uri);
      {
        oprot.writeI32(struct.metamodelUris.size());
        for (java.lang.String _iter12 : struct.metamodelUris)
        {
          oprot.writeString(_iter12);
        }
      }
    }

    @Override
    public void read(org.apache.thrift.protocol.TProtocol prot, ModelSpec struct) throws org.apache.thrift.TException {
      org.apache.thrift.protocol.TTupleProtocol iprot = (org.apache.thrift.protocol.TTupleProtocol) prot;
      struct.uri = iprot.readString();
      struct.setUriIsSet(true);
      {
        org.apache.thrift.protocol.TList _list13 = new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.STRING, iprot.readI32());
        struct.metamodelUris = new java.util.ArrayList<java.lang.String>(_list13.size);
        @org.apache.thrift.annotation.Nullable java.lang.String _elem14;
        for (int _i15 = 0; _i15 < _list13.size; ++_i15)
        {
          _elem14 = iprot.readString();
          struct.metamodelUris.add(_elem14);
        }
      }
      struct.setMetamodelUrisIsSet(true);
    }
  }

  private static <S extends org.apache.thrift.scheme.IScheme> S scheme(org.apache.thrift.protocol.TProtocol proto) {
    return (org.apache.thrift.scheme.StandardScheme.class.equals(proto.getScheme()) ? STANDARD_SCHEME_FACTORY : TUPLE_SCHEME_FACTORY).getScheme();
  }
}

